---
title: XMLHttpRequest.responseText
slug: Web/API/XMLHttpRequest/responseText
tags:
  - API
  - Fetching Text
  - Loading Text
  - Property
  - Read-only
  - Reference
  - XMLHttpRequest
  - responseText
---
<div>{{draft}}</div>

<div>{{APIRef('XMLHttpRequest')}}</div>

<p><span class="seoSummary">The read-only {{domxref("XMLHttpRequest")}} property <strong><code>responseText</code></strong> returns the text received from a server following a request being sent.</span></p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>resultText</var> = <var>XMLHttpRequest</var>.responseText;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} which contains either the textual data received using the <code>XMLHttpRequest</code> or <code>null</code> if the request failed or <code>""</code> if the request has not yet been sent by calling {{domxref("XMLHttpRequest.send", "send()")}}.</p>

<p>While handling an asynchronous request, the value of <code>responseText</code> always has the current content received from the server, even if it's incomplete because the data has not been completely received yet.</p>

<p>You know the entire content has been received when the value of {{domxref("XMLHttpRequest.readyState", "readyState")}} becomes {{domxref("XMLHttpRequest.DONE", "XMLHttpRequest.DONE")}} (<code>4</code>), and {{domxref("XMLHttpRequest.status", "status")}} becomes 200 (<code>"OK"</code>).</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The {{domxref("XMLHttpRequest.responseType")}} is not set to either the empty string or <code>"text"</code>. Since the <code>responseText</code> property is only valid for text content, any other value is an error condition.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var xhr = new XMLHttpRequest();
xhr.open('GET', '/server', true);

// If specified, responseType must be empty string or "text"
xhr.responseType = 'text';

xhr.onload = function () {
    if (xhr.readyState === xhr.DONE) {
        if (xhr.status === 200) {
            console.log(xhr.response);
            console.log(xhr.responseText);
        }
    }
};

xhr.send(null);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-responsetext-attribute')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.responseText")}}</p>
